const express = require('express');
const passport = require("passport");
const router = express.Router();

const encrypt = require("../utils").encrypt;

const User = require("../models/user").User;

router.get("/register", function (req, res, next) {
    res.render("register", {
        messages: req.flash("info").map(msg => ({ body: msg }))
    });
})
    .post("/register", function (req, res, next) {
        User
            .findOne({email: req.body.email})
            .then(u => {
                if(u) {
                    req.flash("info", "Cette adresse email est déjà prise");
                    res.redirect("/register");
                } else {
                    const newUser = new User({ name: req.body.name, email: req.body.email, password: encrypt(req.body.password) });
                    return newUser.save();
                }
            })
            .then(() => res.redirect("/login"), (err) => {
                Object.values(err.errors).forEach(err => req.flash("info", err.message));
                res.redirect("/register");
            })
            .catch(next);
    })
    .get("/login", function (req, res, next) {
        res.render("login");
    })
    .post('/login', passport.authenticate('local', { failureRedirect: '/login', successRedirect: '/' }))
    .get('/logout', function (req, res) {
        req.logout();
        res.redirect('/');
    });

module.exports = router;